## Loading packages----------
require(readr)
require(car)
require(nortest)
require(PerformanceAnalytics)
require(MASS)

require(rsq)
require(effsize)
require(ggeffects)
require(emmeans)

require(ggplot2)
require(corrplot)
require(gridExtra)
require(Rmisc)
require(cowplot)
require(ggpubr)



require(rotl)
require(rncl)
library(readxl)
require(nlme)
require(ape)
require(ggplot2)
require(nortest)
require(readr)
library(qualityTools)
require(gridExtra)
require(phytools)
require(car)
require(gamlss)

require(clusteval)
require(corrplot)
require(ggplot2)
require(car)
require(ggeffects)
require(gamlss)
require(cowplot)

library(geiger)
library(picante)


### creating workspace
setwd("~/Google Drive/1.Files_manuscripts/Triki, Aellen, Van Schaik and Bshary/28.09.2020/R1/Figshare")




## Part 1: brain-body slope in other fish species--------------

##Uploading fish-brain-body dataset-----

data_individuals <- read.csv("fish_brain_body_data.csv", header = T)

head(data_individuals)


### brain-body slope within species----- 

data_individuals <- read.csv("fish_brain_body_data.csv", header = T)
head(data_individuals)

xtabs(~species, data_individuals)## species with N > 10 

summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Atherina_presbyter")))

## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Conger_conger")))

## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Coris_julis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Ctenolabrus_rupestris")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Dicentrarchus_labrax")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Labrus_bergylta")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Lipophrys_pholis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Parablennius_gattorugine")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Scomber_scombrus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Scorpaena_porcus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Serranus_cabrilla")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Spicara_maena")))

## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Spinachia_spinachia")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))


## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Symphodus_melops")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Altolamprologus_compressiceps")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Bathybates_fasciatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Benthochromis_tricoti")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Chalinochromis_brichardi")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Ctenochromis_horei")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Cyathopharynx_furcifer")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Cyprichromis_leptosoma")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Ectodus_descampsii")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Eretmodus_cyanostictus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Gnathochromis_pfefferi")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Haplotaxodon_microlepis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Hippichthys_cyanospilos")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Hippocampus_spinosissimus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Hippocampus_trimaculatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Julidochromis_ornatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)





summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Lepidiolamprologus_elongatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Lepidiolamprologus_profundicola")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)





summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Limnochromis_staneri")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Lobochilotes_labiatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Neolamprologus_modestus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Neolamprologus_multifasciatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Neolamprologus_pulcher")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Neolamprologus_pulcher")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Neolamprologus_savoryi")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Neolamprologus_tetracanthus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Ophthalmotilapia_nasuta")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Ophthalmotilapia_ventralis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Perissodus_microlepis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Petrochromis_famula")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Petrochromis_orthognathus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Pseudosimochromis_curvifrons")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Simochromis_diagramma")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Syngnathoides_biaculeatus")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Syngnathus_schlegeli")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Telmatochromis_temporalis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Trematocara_unimaculatum")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Tropheus_moorii")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Tylochromis_polylepis")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




summary(model1 <- lm(ln.brain.mg~ln.body.g, 
                     data=subset(data_individuals, species=="Xenotilapia_melanogenys")))


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



######## Differences between species slopes------

data_slope <- subset(subset(subset(subset(subset(data_individuals, 
                                   species!="Doryrhamphus_dactyliophorus"), 
                            species!="Lamprologus_ocellatus"), species!="Neolamprologus_multifasciatus"),species!="Neolamprologus_sexfasciatus"),species!="Simochromis_babaulti")

# model
Anova(model1 <- lm(ln.brain.mg~ln.body.g*species_2, 
                     data=data_slope))## excluded significant outliers


## model check---

lillie.test(resid(model1))
plot(resid(model1))
qqPlot(resid(model1))

#check for outliers
outlierTest(model1)## these few outliers do not change the main outcomes

## 95% CI
round(confint(model1), digits=2)

# comparisons of species slopes

emm1 <- (emtrends(model1, ~species_2, var="ln.body.g"))
as.data.frame(emm1)

plot(emm1, comparisons = TRUE) + theme_bw()+xlab("slope estimate")+ylab("")## This is Fig. 2


############ Testing potential effect of size fold and sample size-------

## uplaoding fish slopes dataset----

data_id <- read.csv("fish_slopes.csv", header = T)
data_id <- subset(data_id, species2!="Neolamprologus multifasciatus")## outlier 
head(data_id)

write.csv(data_id, file = "~/Google Drive/1.Files_manuscripts/Triki, Aellen, Van Schaik and Bshary/28.09.2020/R1/Figshare/fish_slopes2.csv")

## size fold and sample size with phylogentic correction----
data_id$species <- as.character(data_id$species)
taxa_id <- tnrs_match_names(names = data_id$species)

taxa_id

## tree of life database and with a valid otId---
hits <- lapply(taxa_id$ott_id, studies_find_trees, property="ot:ottId", detailed = FALSE)
sapply(hits, function(x) sum(x[["n_matched_trees"]]))### check phylo studies on our species

tree <- tol_induced_subtree(ott_ids = taxa_id$ott_id, label_format="name")
tree.length <- compute.brlen(tree, method="Grafen")#### add branch length to the tree follwoing methods in: https://www.r-phylo.org/wiki/HowTo/DataTreeManipulation
plot(tree.length, cex = .5, label.offset = .1, no.margin = TRUE,use.edge.length=T)
add.scale.bar(cex = 0.7, font = 2, col = "red")

plotTree(tree,pts=F,lwd=3,node.numbers=T)

### making species to be the row.names of our data frame
data_id1 <- data.frame(data_id[,-1], row.names=data_id$species)
mydata<-data_id1[tree$tip.label,]


### The GLS models----

### Estimation of lambda

pglsModel1 <- gls(slope~log(sample_size), 
                  correlation = 
                    corPagel(value = 1,phy = tree.length,fixed = FALSE),
                  data=mydata)

pglsModel2 <- gls(slope~log(size_fold), 
                  correlation = 
                    corPagel(value = 1,phy = tree.length,fixed = FALSE),
                  data=mydata)

pglsModel1# lambda = 0.55

#check for outliers
mydata$new <- resid(pglsModel1, phylo = TRUE)
mydata$new1<- mydata$new/sqrt(var(mydata$new))[1] #standardises residuals by sqrt of their variance
View(mydata)## initially we found "Neolamprologus multifasciatus" to be an outlier and that's why it has been excluded from the analyses (you can check this by rerunning the script without excluding this species)


pglsModel2# lambda = 0.47
#check for outliers
mydata$new <- resid(pglsModel2, phylo = TRUE)
mydata$new1<- mydata$new/sqrt(var(mydata$new))[1] #standardises residuals by sqrt of their variance



summary(pglsModel1)
summary(pglsModel2)

## Sample_size Final model with the selected lambda
pglsModel_final1 <- gls(slope~log(sample_size), 
                       correlation = corPagel(value = 0.55,phy = tree.length,fixed = TRUE),
                       data.frame(mydata))
pglsModel_final1

summary(pglsModel_final1)


### assumptions for best model
qqPlot(resid(pglsModel_final1, phylo = TRUE))
lillie.test(resid(pglsModel_final1))
hist(resid(pglsModel_final1))
plot(pglsModel_final1, resid(., type="n")~fitted(.), col="blue", main="Normalized Residuals vs. Fitted Values",
     abline=c(0,0))

## 95% CI
round(confint(pglsModel_final1), digits=2)


## explained variance
rsquared(pglsModel_final1)


## Final model with the selected lambda
pglsModel_final2 <- gls(slope~log(size_fold), 
                        correlation = corPagel(value = 0.47,phy = tree.length,fixed = TRUE),
                        data.frame(mydata))
pglsModel_final2

summary(pglsModel_final2)

### assumptions for best model
qqPlot(resid(pglsModel_final2))
hist(resid(pglsModel_final2))
plot(pglsModel_final2, resid(., type="n")~fitted(.), col="blue", main="Normalized Residuals vs. Fitted Values",
     abline=c(0,0))

## 95% CI
round(confint(pglsModel_final2), digits=2)

## p-value for lambda vs zero: testing whether lambda is significantly different from the null hypothesis zero

##another way of estimating lambda----
#Calculate likelihood over the entire range
##[from Symonds&Blombergs tutorial!]

lambda <- seq(0, 1, length.out = 100)

lik <- sapply(lambda, function(lambda) logLik(gls(slope~log(sample_size), data=mydata, 
                                                  correlation = corPagel(value=lambda, phy=tree.length, fixed = TRUE))))


plot(lik ~ lambda, type = "l", 
     main = expression(paste("Likelihood Plot for ",lambda)), 
     ylab = "Log Likelihood", xlab = expression(lambda))

abline(v=pglsModel_final1$modelStruct, col = "red")


lik2 <- sapply(lambda, function(lambda) logLik(gls(slope~log(size_fold), data=mydata, 
                                                  correlation = corPagel(value=lambda, phy=tree.length, fixed = TRUE))))


plot(lik2 ~ lambda, type = "l", 
     main = expression(paste("Likelihood Plot for ",lambda)), 
     ylab = "Log Likelihood", xlab = expression(lambda))

abline(v=pglsModel_final2$modelStruct, col = "red")

## Phylogenetic signal in slope values

slope <- mydata[, 6]
names(slope) <- rownames(mydata)

phylosignal(slope, tree.length)
phylosig(tree.length, slope, method = "lambda", test = T)


## Part 2: Cleaner fish-------


# Uploading Cleaner fish datasets------

## Creating a work space

data_brain <- read.csv("data_brain.csv",header=TRUE, sep=",")
head(data_brain)

data_cognition <- read.csv("data_cognition.csv",header=TRUE, sep=",")
head(data_cognition)



### I- Brain-Body slope in cleaner fish-----

## I- MRI data----

########
# total brain
summary(model1 <- lm(log(brain_size)~log(weight), 
                     data=subset(data_brain, method=="MRI")))




## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))

## 95% CI
round(confint(model1), digits=2)

###############
# telencephalon
summary(model1 <- lm(log(telencephalon)~log(weight), 
                     data=subset(data_brain, method=="MRI")))




## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))

## 95% CI
round(confint(model1), digits=2)

##############
# diencephalon
summary(model1 <- lm(log(diencephalon)~log(weight), 
                     data=subset(data_brain, method=="MRI")))




## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


##########
# midbrain
summary(model1 <- lm(log(midbrain)~log(weight), 
                     data=subset(data_brain, method=="MRI")))




## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))

## 95% CI
round(confint(model1), digits=2)



############
# cerebellum
summary(model1 <- lm(log(cerebellum)~log(weight), 
                     data=subset(data_brain, method=="MRI")))




## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))

## 95% CI
round(confint(model1), digits=2)


#############
# brain_stem
summary(model1 <- lm(log(brain_stem)~log(weight), 
                     data=subset(data_brain, method=="MRI")))




## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))

## 95% CI
round(confint(model1), digits=2)




## I- Dissection data----

############
## Total brain 

summary(model2 <- lm(log(brain_size)~log(weight), 
                     data=subset(data_brain, method=="dissection")))



## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))

## 95% CI
round(confint(model2), digits=2)


############
## telencephalon

summary(model2 <- lm(log(telencephalon)~log(weight), 
                     data=subset(data_brain, method=="dissection")))



## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))

## 95% CI
round(confint(model2), digits=2)


############
## diencephalon

summary(model2 <- lm(log(diencephalon)~log(weight), 
                     data=subset(data_brain, method=="dissection")))



## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))

## 95% CI
round(confint(model2), digits=2)


############
## midbrain

summary(model2 <- lm(log(midbrain)~log(weight), 
                     data=subset(data_brain, method=="dissection")))



## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))

## 95% CI
round(confint(model2), digits=2)


############
## cerebellum

summary(model2 <- lm(log(cerebellum)~log(weight), 
                     data=subset(data_brain, method=="dissection")))



## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))

## 95% CI
round(confint(model2), digits=2)


############
## brain_stem

summary(model2 <- lm(log(brain_stem)~log(weight), 
                     data=subset(data_brain, method=="dissection")))



## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))

## 95% CI
round(confint(model2), digits=2)


## II- Cognition-body slope-------------------------------------


# II-1 Reversal learning----	

data_cognition$rank_reversal <- rank(-data_cognition$reversal)## ranking performance from low to high performers

summary(model1 <- glm(round(rank_reversal)~log(weight), 
                      data=data_cognition, family=quasipoisson))## overdispersion with poisson family

## checking the model assumptions
lillie.test(resid(model1))
par(mfrow = c(2, 2)); plot(model1); par(mfrow = c(1, 1))
lmtest::bptest(model1)
plot(resid(model1))
AER::dispersiontest(model1,trafo=1)## used for same model but with Poisson family to test overdispersion


## 95% CI
round(confint(model1), digits=2)



## II-2 Detour Task----

data_cognition$rank_detour <- rank(-data_cognition$detour_touch)## ranking performance from low to high performers

summary(model2 <- glm(round(rank_detour)~log(weight), 
                      data=data_cognition, family=quasipoisson))## overdispersion with poisson family

## checking the model assumptions
lillie.test(resid(model2))
par(mfrow = c(2, 2)); plot(model2); par(mfrow = c(1, 1))
lmtest::bptest(model2)
plot(resid(model2))
AER::dispersiontest(model2,trafo=1)## used for same model but with Poisson family to test overdispersion


## 95% CI
round(confint(model2), digits=2)


## II-3 Numerical descrimination task----

data_cognition$rank_numbering <- rank(data_cognition$numbering_success_prop)## ranking performance from low to high performers

summary(model3 <- glm(round(rank_numbering)~log(weight), 
                      data=data_cognition, family=quasipoisson))## overdispersion with poisson family

## checking the model assumptions
lillie.test(resid(model3))
par(mfrow = c(2, 2)); plot(model3); par(mfrow = c(1, 1))
lmtest::bptest(model3)
plot(resid(model3))
AER::dispersiontest(model3,trafo=1)## used for same model but with Poisson family to test overdispersion


## 95% CI
round(confint(model3), digits=2)


## II-4 Feeding preference task----

data_cognition$rank_feed <- rank(data_cognition$feeding_pref_ratio)## ranking performance from low to high performers

summary(model4 <- glm(round(rank_feed)~log(weight), 
                      data=data_cognition, family=quasipoisson))## overdispersion with poisson family

## checking the model assumptions
lillie.test(resid(model4))
par(mfrow = c(2, 2)); plot(model4); par(mfrow = c(1, 1))
lmtest::bptest(model4)
plot(resid(model4))
AER::dispersiontest(model4,trafo=1)## used for same model but with Poisson family to test overdispersion


## 95% CI
round(confint(model4), digits=2)

### Figures----------------------------------------------------

## Fig.1------

data_2 <- read.csv("fish_slopes2.csv", header = T)
data_2 <- subset(data_2, species2!="Neolamprologus multifasciatus")## outlier 


plot1 <- ggplot(data_2, aes(y=slope, x=log(sample_size),colour=species2))+
  geom_errorbar(aes(ymin=CI_lower, ymax=CI_upper), width=.05, colour="#5F9EA0")+
  geom_abline(intercept = 0.78, slope = -0.10, colour="black")+
  ylab("Brain-body slope")+geom_point(size=1.5,alpha = 0.8)+
  xlab("Sample size (log scale)")+
  theme_classic()+
  theme(legend.position="none",
        plot.margin = unit(c(6,10,10,10), "pt"))+
  annotate(geom = "text", x = 3.25, y = 2, label = "slope = -0.10",
           angle = 0, size=3)

plot2 <- ggplot(data_2, aes(y=slope, x=log(size_fold),colour=species2))+
  geom_errorbar(aes(ymin=CI_lower, ymax=CI_upper), width=.05, colour="#5F9EA0")+
  geom_abline(intercept = 0.5, slope = -0.013, colour="black")+
  ylab("Brain-body slope")+geom_point(size=1.5,alpha = 0.8)+
  xlab("Body size ratio (largest/smallest) \n (log scale)")+
  theme_classic()+
  theme(legend.position="none",
        plot.margin = unit(c(6,10,10,10), "pt"))+
  annotate(geom = "text", x = 2.5, y = 2, label = "slope = -0.013",
           angle = 0, size=3)

Fig1 <- plot_grid(plot1,plot2,
                  label_x=0.09, nrow=2)


Fig1


## Fig.2-species slopes comparisons----

plot(emm1, comparisons = TRUE) + theme_bw()+xlab("slope estimate")+ylab("")## see above for the code

# Fig.3-MRI------ 
## total brain-body weight and brain parts-body weight in cleaner fish

data_1 <- subset(data_brain, method=="MRI")
data_1 <- data_1[,c("cleaner_ID","weight", "brain_size", 
                  "telencephalon", "diencephalon", "midbrain",
                  "cerebellum", "brain_stem")]

data_1 <- reshape::melt(data_1, id=c("cleaner_ID", "weight"))

head(data_1)


  
  
ggplot(data_1, aes(y=log(value), x=log(weight)))+
    geom_smooth(method="lm",
                color="black", size=0.5)+facet_wrap(~variable, scales="free")+
    labs(y=expression(paste("Log size ",(mm^{3}))))+geom_point(size=1.5,alpha = 0.8, colour="#0072B2")+
    xlab("Log body weight (g)")+
    theme_classic()+ theme(plot.margin = unit(c(6,0,6,10), "pt"))+ggtitle("MRI scans data")
  


# Fig.4-dissection------ 
## total brain-body weight and brain parts-body weight in cleaner fish

data_2 <- subset(data_brain, method=="dissection")
data_2 <- data_2[,c("cleaner_ID","weight", "brain_size", 
                    "telencephalon", "diencephalon", "midbrain",
                    "cerebellum", "brain_stem")]

data_2 <- reshape::melt(data_2, id=c("cleaner_ID", "weight"))

head(data_2)




ggplot(data_2, aes(y=log(value), x=log(weight)))+
  geom_smooth(method="lm",
              color="black", size=0.5)+facet_wrap(~variable, scales="free")+
  labs(y=expression(paste("Log size ",(mg))))+geom_point(size=1.5,alpha = 0.8, colour="coral")+
  xlab("Log body weight (g)")+
  theme_classic()+ theme(plot.margin = unit(c(6,0,6,10), "pt"))+ggtitle("Dissection data")



# Fig.5----



plot1 <- ggplot(data_cognition, aes(x=log(weight), y=rank_reversal))+ 
  geom_point(size=1.5,alpha = 0.8, colour="coral3")+
  xlab("Log body weight (g)")+
  ylab("Performance rank")+
  expand_limits(y=0)+
  labs(col="")+geom_smooth(method="glm", 
                           method.args = list(family = "quasipoisson"),
                           color="black", size=0.5)+
  theme_classic()+ theme(plot.margin = unit(c(6,0,6,10), "pt"))+
  theme(axis.title=element_text(size=10))+
  annotate("text", x = 1.2, y = 75,size=3, 
           label = "slope == -0.40", parse = TRUE)+
  theme(legend.position="none",
        plot.title = element_text(hjust = 0.5, size=10),
        axis.title=element_text(size=10))+ ggtitle("Reversal learning task \n ")



plot2 <- ggplot(data_cognition, aes(x=log(weight), y=rank_detour))+ 
  geom_point(size=1.5,alpha = 0.8, colour="coral3")+
  xlab("Log body weight (g)")+
  ylab("Performance rank")+
  expand_limits(y=0)+
  labs(col="")+geom_smooth(method="glm", 
                           method.args = list(family = "quasipoisson"), color="black", size=0.5)+
  theme_classic()+ theme(plot.margin = unit(c(6,0,6,10), "pt"))+
  theme(axis.title=element_text(size=10))+
  annotate("text", x = 1.2, y = 75,size=3, 
           label = "slope == 0.18", parse = TRUE)+
  theme(legend.position="none",
        plot.title = element_text(hjust = 0.5, size=10),
        axis.title=element_text(size=10))+ ggtitle("Detour task  \n ")



plot3 <- ggplot(data_cognition, aes(x=log(weight), y=rank_numbering))+ 
  geom_point(size=1.5,alpha = 0.8, colour="coral3")+
  xlab("Log body weight (g)")+
  ylab("Performance rank")+
  expand_limits(y=0)+
  labs(col="")+geom_smooth(method="glm", 
                           method.args = list(family = "quasipoisson"), color="black", size=0.5)+
  theme_classic()+ theme(plot.margin = unit(c(6,0,6,10), "pt"))+
  theme(axis.title=element_text(size=10))+
  annotate("text", x = 1.2, y = 75,size=3, 
           label = "slope == 0.21", parse = TRUE)+
  theme(legend.position="none",
        plot.title = element_text(hjust = 0.5, size=10),
        axis.title=element_text(size=10))+ ggtitle("Numerical descrimination  \n task")



plot4 <- ggplot(data_cognition, aes(x=log(weight), y=rank_feed))+ 
  geom_point(size=1.5,alpha = 0.8, colour="coral3")+
  xlab("Log body weight (g)")+
  ylab("Performance rank")+
  expand_limits(y=0)+
  labs(col="")+geom_smooth(method="glm", 
                           method.args = list(family = "quasipoisson"), color="black", size=0.5)+
  theme_classic()+ theme(plot.margin = unit(c(6,0,6,10), "pt"))+
  theme(axis.title=element_text(size=10))+
  annotate("text", x = 1.2, y = 75,size=3, 
           label = "slope == 0.32", parse = TRUE)+
  theme(legend.position="none",
        plot.title = element_text(hjust = 0.5, size=10),
        axis.title=element_text(size=10))+ ggtitle("Feeding against \n the preferences task")





Fig2 <- plot_grid(plot1,plot2, NULL, NULL, plot3,plot4, labels=c("a", "b", "", "", "c", "d"), 
                  label_x=0.09, nrow=3,
                  ncol=2,label_size=11, align = c("h", "v"),
                  rel_heights = c(1,0.1, 1))


Fig2




